setwd("/Users/...")

rm(list=ls())
table3.FF <- read.csv("table3.FF.csv", header=T)
table3.KL.SDF<- read.csv("table3.SDF.KL.csv", header=T)
table3.PSN.SDF<- read.csv("table3.SDF.PSN.csv", header=T)

par(mar=c(4,4,3,1))
par(mfrow=c(3,2))

#300 portfolios,KL, r2#
x<-table3.KL.SDF$X
y<-table3.KL.SDF$r2
plot(x,y, type ="h", xlab="alpha", ylab="", main="KL", col="blue",lwd=2)
title(ylab=expression("adj.R"^{2}), line=2)
abline(h=table3.FF$r2, col="red", lwd=2, lty=2)
text(x=0,y=table3.FF$r2,labels="FF", col="red",pos=3)
abline(v=0.90, col="darkgreen", lwd=2, lty=3)

#300 portfolios,PSN r2#
x<-table3.PSN.SDF$X
y<-table3.PSN.SDF$r2
plot(x,y, type ="h", xlab="alpha", ylab="", main="PSN 1", col="blue",lwd=2)
title(ylab=expression("adj.R"^{2}), line=2)
abline(h=table3.FF$r2, col="red", lwd=2, lty=2)
text(x=0,y=table3.FF$r2,labels="FF", col="red",pos=3)
abline(v=0.475, col="darkgreen", lwd=2, lty=3)


#300 portfolios,KL const#
x<-table3.KL.SDF$X
y<-table3.KL.SDF$con
plot(x,y,ylim=c(-1, 5), type ="h", xlab="alpha", ylab="", main="KL", col="blue",lwd=2)
title(ylab="const.", line=2)
abline(h=table3.FF$con, col="red", lwd=2, lty=2)
text(x=0,y=table3.FF$con,labels="FF", col="red",pos=1)
abline(v=0.90, col="darkgreen", lwd=2, lty=3)

#300 portfolios,PSN, const#
x<-table3.PSN.SDF$X
y<-table3.PSN.SDF$con
plot(x,y, ylim=c(-1, 5), type ="h", xlab="alpha", ylab="", main="PSN 1", col="blue",lwd=2)
title(ylab="const.", line=2)
abline(h=table3.FF$con, col="red", lwd=2, lty=2)
text(x=0.1,y=table3.FF$con,labels="FF", col="red",pos=1)
abline(v=0.475, col="darkgreen", lwd=2, lty=3)


#300 portfolios,KL lamda#
x<-table3.KL.SDF$X
y<-table3.KL.SDF$lamda
plot(x,y, type ="h", xlab="alpha", ylab="", main="KL", col="blue",lwd=2)
title(ylab="risk price", line=2)
abline(v=0.90, col="darkgreen", lwd=2, lty=3)


#300 portfolios,PSN, lamda#
x<-table3.PSN.SDF$X
y<-table3.PSN.SDF$lamda
plot(x,y, type ="h", xlab="alpha", ylab="", main="PSN 1", col="blue",lwd=2)
title(ylab="risk price", line=2)
abline(v=0.475, col="darkgreen", lwd=2, lty=3)

