setwd("/Users/...")

pdata <- read.csv("300_Portfolios_fortest.csv", header=T)

pdata <- pdata[1:210,]
pdata <- pdata[!colSums(pdata)%in% NA]

penalty <- seq(from = 0, to = 1, by = 0.025)
l.penalty <- length(penalty)

t <- (ncol(pdata)-1)

table3.SDF.PSN <- matrix(NA,ncol = 5,nrow = l.penalty)

colnames(table3.SDF.PSN ) <-c("con","lamda","t.con","t.lamda", "r2")
rownames(table3.SDF.PSN) <- penalty

PSN.sdf.1 <- read.csv("300ff.PSN.sdf.1.csv", header=F)
PSN.sdf.2 <- read.csv("300ff.PSN.sdf.2.csv", header=F)
PSN.sdf.3 <- read.csv("300ff.PSN.sdf.3.csv", header=F)
PSN.sdf.4 <- read.csv("300ff.PSN.sdf.4.csv", header=F)




sdf.all <- cbind(PSN.sdf.1[,-(1:3)],PSN.sdf.2[,-(1:3)],PSN.sdf.3[,-(1:3)],PSN.sdf.4[,-(1:3)])
reorder.sdf.all <- sdf.all[,order(sdf.all [1,])]

matrixofdates <- cbind(PSN.sdf.1[,(2:3)],reorder.sdf.all)
colnames(matrixofdates) <-c("year","month",penalty)
matrixofdates <- matrixofdates[-1,]


for (j in 3:(2+l.penalty)){

#pick our recovered sdf
sdf <- as.matrix(as.numeric(matrixofdates[,j]))

#create an empty vector of length 25, which is the number of testing assets
v.betas <- matrix(NA,  nrow = t, ncol = 1)

#for each asset, run time series regresstion to get beta
for (i in 1:t){
  
  y<- pdata[ ,(i+1)]
  fit1 <- lm( y ~ sdf)

  v.betas[i,1] <-coefficients(fit1)[2]
  
}


#calculate mean return for each asset
pdata1 <- pdata[,2:ncol(pdata)]
meanr <- as.vector(colMeans(pdata1))

#second pass, run mean return on estimated beta
finalfit <- lm(meanr ~ v.betas)
output<-summary(finalfit)

table3.SDF.PSN[(j-2),1:2] <- output$coefficients[,1]
table3.SDF.PSN[(j-2),3:4] <- output$coefficients[,3]
table3.SDF.PSN[(j-2),5] <- output$adj.r.squared

}



write.csv(table3.SDF.PSN,file="table3.SDF.PSN.csv")


