##--------------------------------------------------------------------------------##
##--------------------------------------------------------------------------------##
##----------  Step 0: Change the following to your working directory -------------##
##--------------------------------------------------------------------------------##
##--------------------------------------------------------------------------------##

setwd("/Users/...")

##--------------------------------------------------------------------------------##
##--------------------------------------------------------------------------------##
##----------      Step 1: Prepare data & load related packages     ---------------##
##--------------------------------------------------------------------------------##
##--------------------------------------------------------------------------------##


rm(list=ls())
penalty <- c(0,0.1)
library(glmnet)
rf <- read.csv("rf.csv",header=T)
rawdata <- read.csv("100FFm.csv",header=T)

##--------------------------------------------------------------------------------##
##--------------------------------------------------------------------------------##
##----------   Step 2 : Create an empty matrix containing        -----------------##
#-------------         all dates we want for the exercise        -----------------##
##--------------------------------------------------------------------------------##
##--------------------------------------------------------------------------------##


rawdata$date <- as.numeric(substr(rawdata$date,1,6))
rf$date<- as.numeric(substr(rf$date,1,6))

MonthsVector <- c("01","02","03","04","05","06","07","08","09","10","11","12")

startyear <- as.numeric(substr(196307,1,4))
startmonth <- substr(196307,5,6)
endyear <- as.numeric(substr(201012,1,4))
endmonth <- substr(201012,5,6)
nbofyears <- endyear - startyear
matrixofdates <- NULL
for(i in 0:nbofyears){
  for(r in 1:12){
    matrixofdates <- rbind(matrixofdates,c(startyear+i,MonthsVector[r]))
  }
}

matrixofdates <- matrixofdates[7:nrow(matrixofdates),]

newmatrix <- matrix(, nrow = nrow(matrixofdates), ncol = 2)

matrixofdates <- cbind(matrixofdates,newmatrix)

colnames(matrixofdates)[3:4] <- penalty

##--------------------------------------------------------------------------------##
##----------  Step 3: create a loop to extract out-of-sample SDF  ----------------##
#-----------            in a rolling fashion                      ----------------##
##--------------------------------------------------------------------------------##


for(i in 1:nrow(matrixofdates)) {
  

    if (matrixofdates[i,2] %in% c("07") & i == 565){
   
      predictiondate<-as.numeric(paste(matrixofdates[i,1], matrixofdates[i,2],sep=""))
      predictionenddate <- as.numeric(paste(matrixofdates[i+5,1], matrixofdates[i+5,2],sep=""))  

      
      predictionyear<-as.numeric(substr(predictiondate,1,4))
      predictionmonth<-substr(predictiondate,5,6)
       lastmonth <- MonthsVector[as.numeric(predictionmonth)-1]
       lastyear<- predictionyear
       beginyear<- lastyear-30
       beginmonth<-predictionmonth
       begindate <- as.numeric(paste(beginyear, beginmonth,sep=""))
       lastdate <- as.numeric(paste(lastyear,lastmonth,sep=""))
       

       toy <- rawdata[which(rawdata$date >=begindate & rawdata$date <=predictionenddate),]
       toyrf <- rf[which(rf$date  >=begindate & rf$date <= predictionenddate),]
    
       toy <- toy[!colSums(toy)%in% NA]
       
    
       asset.no<- ncol(toy)-1
       
       totalx <- toy[,-1]
       
       toyrf <-toyrf[,2]
 
       totalrfm <- matrix(toyrf, nrow=length(toyrf),ncol=asset.no)
       
       toyrfm <- totalrfm
    
       totalx  <- totalx-toyrfm
       
       x<- as.matrix(totalx[1:(nrow(totalx)-6),])
 
       xpredict <- as.matrix(tail(totalx, 6))
       
       y<- rep(0,360)
       y <- as.matrix(y)
       
       fit = glmnet(x, y, family = "poisson", intercept=FALSE, standardize=FALSE,alpha=1)
       
       predict1 <- predict(fit, newx=xpredict, s=penalty, type="response")
       
       dqdp <- sweep(predict1, 2, colMeans(predict1), "/" )
       
       mhat <- dqdp
       
       matrixofdates[i:(i+5),3:4] <- mhat
       
    } else if (matrixofdates[i,2] %in% c("07") & i!= 565){  

      predictiondate<-as.numeric(paste(matrixofdates[i,1], matrixofdates[i,2],sep=""))
      predictionenddate <- as.numeric(paste(matrixofdates[i+11,1], matrixofdates[i+11,2],sep=""))  
      
      
      predictionyear<-as.numeric(substr(predictiondate,1,4))
      predictionmonth<-substr(predictiondate,5,6)
      lastmonth <- MonthsVector[as.numeric(predictionmonth)-1]
      lastyear<- predictionyear
      beginyear<- lastyear-30
      beginmonth<-predictionmonth
      begindate <- as.numeric(paste(beginyear, beginmonth,sep=""))
      lastdate <- as.numeric(paste(lastyear,lastmonth,sep=""))
      
      
      toy <- rawdata[which(rawdata$date >=begindate & rawdata$date <=predictionenddate),]
      toyrf <- rf[which(rf$date  >=begindate & rf$date <= predictionenddate),]
      
      toy <- toy[!colSums(toy)%in% NA]
      
      asset.no<- ncol(toy)-1
      

      totalx <- toy[,-1]
 
      toyrf <-toyrf[,2]
 
      totalrfm <- matrix(toyrf, nrow=length(toyrf),ncol=asset.no)
      
      toyrfm <- totalrfm
  
      totalx  <- totalx-toyrfm
      

      x<- as.matrix(totalx[1:(nrow(totalx)-12),])
   
      xpredict <- as.matrix(tail(totalx, 12))
      
      y<- rep(0,360)
      y <- as.matrix(y)
      
      fit = glmnet(x, y, family = "poisson", intercept=FALSE, standardize=FALSE,alpha=1)
      
      predict1 <- predict(fit, newx =xpredict, s=penalty, type="response")    
      
      dqdp <- sweep(predict1, 2, colMeans(predict1), "/" )
    
      mhat <- dqdp
      
      matrixofdates[i:(i+11),3:4] <- mhat
    
  }
       
  print(paste(round(i/nrow(matrixofdates)*100),"% done for the loop.",sep=""))
  

}


##--------------------------------------------------------------------------------##
##----------  Step 3-1: save  out-of-sample SDF to a csv file      ---------------##
##--------------------------------------------------------------------------------##
write.csv(matrixofdates,file="100ff.sdf.est.csv")

##--------------------------------------------------------------------------------##
##----------  Step 4: Conduct cross sectional regression tests     ---------------##
#-----------            using extracted SDF                       ----------------##
##--------------------------------------------------------------------------------##

pdata <- read.csv("100_Portfolios.csv", header=T)
pdata <- pdata[1:570,]
pdata <- pdata[!colSums(pdata)%in% NA]

t <- (ncol(pdata)-1)

table6.A.SDF <- matrix(NA,ncol = 5,nrow = 2)

colnames(table6.A.SDF ) <-c("con","lamda","t.con","t.lamda", "r2")
rownames(table6.A.SDF) <- penalty

for (j in 3:4){
  
  
  #pick our recovered sdf
  sdf <- as.matrix(as.numeric(matrixofdates[,j]))
  
  #create an empty vector of length 25, which is the number of testing assets
  v.betas <- matrix(NA,  nrow = t, ncol = 1)
  
  #for each asset, run time series regresstion to get beta
  for (i in 1:t){
    
    y<- pdata[,(i+1)]
    fit1 <- lm( y ~ sdf)
    
    v.betas[i,1] <-coefficients(fit1)[2]
    
  }
  
  
  #calculate mean return for each asset
  pdata1 <- pdata[,2:ncol(pdata)]
  meanr <- as.vector(colMeans(pdata1))
  
  #second pass, run mean return on estimated beta
  finalfit <- lm(meanr ~ v.betas)
  output<-summary(finalfit)
  
  table6.A.SDF[(j-2),1:2] <- output$coefficients[,1]
  table6.A.SDF[(j-2),3:4] <- output$coefficients[,3]
  table6.A.SDF[(j-2),5] <- output$adj.r.squared
  
}

####-----------------------------------------------------##
###-----   Benchmark Fama French three factors case -----##
####-----------------------------------------------------##


table6.A.FF <- matrix(NA,ncol = 9,nrow = 1)

colnames(table6.A.FF ) <-c("con","rm", "SMB", "HML", "t.con","t.rm","t.SMB","t.HML","r2")


fffactor <- read.csv("F-F__Factors.CSV", header=T)

v.betas <- - matrix(, nrow = t, ncol = 3)

for (i in 1:t){
  
  y<- pdata[,(i+1)]
  fit1 <- lm( y ~ fffactor[,2]+fffactor[,3]+fffactor[,4])
  
  v.betas[i,1] <-coefficients(fit1)[2]
  v.betas[i,2] <-coefficients(fit1)[3]
  v.betas[i,3] <-coefficients(fit1)[4]
  
}


pdata1 <- pdata[2:ncol(pdata)]
meanr <- as.vector(colMeans(pdata1))


finalfit <- lm(meanr ~ v.betas[,1:3])
output.FF <- summary(finalfit)

table6.A.FF[1,1:4] <- output.FF$coefficients[,1]
table6.A.FF[1,5:8] <- output.FF$coefficients[,3]
table6.A.FF[1,9] <- output.FF$adj.r.squared

##--------------------------------------------------------------------------------##
##----------  Step 4-1: save  cross sectional regression results  to a csv file --##
##--------------------------------------------------------------------------------##
write.csv(table6.A.SDF,file="table6.A.SDF.csv")
write.csv(table6.A.FF,file="table6.A.FF.csv")


